<?php

namespace App\Router\Middleware;
use App\Router\Session;
use Network\IAuthService;
use Shared\Log;
use App\Router\Request\IRequest;
use App\Router\Response\RedirectResponse;
class AuthMiddleware extends Middleware {

    private IAuthService $auth;
    public function __construct(IAuthService $auth) {
        $this->auth = $auth;
    }
    public function handle(IRequest $request, callable $next) {
        $excludedUrls = ['/login', '/register','/forgetPassword', '/'];
//        Log::dd($this->auth->getCurrentUser());
        if ($this->auth->getCurrentUser() === null && !in_array($request->getRequestUri(), $excludedUrls)) {
            $resp = new RedirectResponse("/login");
            $resp->send();
            exit;
        }        
        return parent::handle($request, $next);
    }
}