<?php

namespace Database;
use DateTime;
use Model\Activity;
use Shared\Log;

class ActivityMapper {
    public function activitySqlToEntity(array $data):array
    {
        $activityEntities = [];

        foreach ($data as $activityData) {
            $activity = new ActivityEntity();

            if (isset($activityData['idActivite'])) {
                $activity->setIdActivity($activityData['idActivite']);
            }

            if (isset($activityData['type'])) {
                $activity->setType($activityData['type']);
            }

//            if (isset($activityData['date'])) {
//                $activity->setDate(DateTime::createFromFormat('yyyy-mm--dd',$activityData['date']));
//            }

            if (isset($activityData['heureDeDebut'])) {
                $activity->setHeureDebut(new DateTime($activityData['heureDeDebut']));
            }

            if (isset($activityData['heureDeFin'])) {
                $activity->setHeureFin(new DateTime($activityData['heureDeFin']));
            }

            if (isset($activityData['effortRessent'])) {
                $activity->setEffortRessenti($activityData['effortRessent']);
            }

            if (isset($activityData['variabilite'])) {
                $activity->setVariabilite($activityData['variabilite']);
            }

            if (isset($activityData['variance'])) {
                $activity->setVariance($activityData['variance']);
            }

            if (isset($activityData['ecartType'])) {
                $activity->setEcartType($activityData['ecartType']);
            }

            if (isset($activityData['moyenne'])) {
                $activity->setMoyenne($activityData['moyenne']);
            }

            if (isset($activityData['maximum'])) {
                $activity->setMaximum($activityData['maximum']);
            }

            if (isset($activityData['minimum'])) {
                $activity->setMinimum($activityData['minimum']);
            }

            if (isset($activityData['temperatureMoyenne'])) {
                $activity->setTemperatureMoyenne($activityData['temperatureMoyenne']);
            }

            $activityEntities[] = $activity;
        }
        Log::dd($activityEntities);
        return $activityEntities;
    }

    /**
     * @throws \Exception
     */
    public function ActivityEntityToModel(ActivityEntity $activiteEntity):Activity {
        $date = new DateTime($activiteEntity->getDate());
        $heureDebut = new \DateTime($activiteEntity->getHeureDebut());
        $heureFin = new \DateTime($activiteEntity->getHeureFin());
        $effortRessenti = intval($activiteEntity->getEffortRessenti());
        $variability = floatval($activiteEntity->getVariability());
        $variance = floatval($activiteEntity->getVariance());
        $ecartType = floatval($activiteEntity->getEcartType());

        $act = new Activity(
            $activiteEntity->getType(),
            $date,
            $heureDebut,
            $heureFin,
            $effortRessenti,
            $variability,
            $variance,
            $ecartType,
            $activiteEntity->getMoyenne(),
            $activiteEntity->getMaximum(),
            $activiteEntity->getMinimum(),
            $activiteEntity->getTemperatureMoyenne(),
            'false'
        );

        return $act;
    }
    //public function ActivityToEntity(Activity model): ActivityEntity;

    public function activityToEntity(Activity $act):ActivityEntity{
        $actEntity = new ActivityEntity();
        $actEntity->setIdActivity($act->getIdActivity());
        $actEntity->setType($act->getType());
        $actEntity->setDate($act->getDate());
        $actEntity->setHeureDebut($act->getHeureDebut());
        $actEntity->setHeureFin($act->getHeureFin());
        $actEntity->setEffortRessenti($act->getEffortRessenti());
        $actEntity->setVariabilite($act->getVariability());
        $actEntity->setVariance($act->getVariance());
        $actEntity->setEcartType($act->getStandardDeviation());
        $actEntity->setMoyenne($act->getAverage());
        $actEntity->setMaximum($act->getMaximum());
        $actEntity->setMinimum($act->getMinimum());
        $actEntity->setTemperatureMoyenne($act->getAvrTemperature());

        return $actEntity;
    }
}

?>
