<?php

namespace Database;
use Model\User;
use \PDO;
use \DateTime;
use Model\Role;
use Model\Athlete;
use Shared\Log;

class AthleteMapper {
    public function athleteSqlToEntity(array $data): array {
        $athleteEntities = [];

        foreach ($data as $athleteData) {
            $athlete = new AthleteEntity();
            if (isset($athleteData['idAthlete'])) {
                $athlete->setIdAthlete($athleteData['idAthlete']);
            }

            if (isset($athleteData['nom'])) {
                $athlete->setNom($athleteData['nom']);
            }

            if (isset($athleteData['prenom'])) {
                $athlete->setPrenom($athleteData['prenom']);
            }

            if (isset($athleteData['username'])) {
                $athlete->setUsername($athleteData['username']);
            }

            if (isset($athleteData['email'])) {
                $athlete->setEmail($athleteData['email']);
            }

            if (isset($athleteData['sexe'])) {
                $athlete->setSexe($athleteData['sexe']);
            }

            if (isset($athleteData['taille'])) {
                $athlete->setTaille($athleteData['taille']);
            }

            if (isset($athleteData['poids'])) {
                $athlete->setPoids($athleteData['poids']);
            }

            if (isset($athleteData['motDePasse'])) {
                $athlete->setMotDePasse($athleteData['motDePasse']);
            }

            if (isset($athleteData['dateNaissance'])) {
                $athlete->setDateNaissance($athleteData['dateNaissance']);
            }

            if (isset($athleteData['isCoach'])) {
                $athlete->setIsCoach($athleteData['isCoach']);
            }

            $athleteEntities[] = $athlete;
        }

        return $athleteEntities;
    }
    
    public function athleteEntityToModel(AthleteEntity $athleteEntity): User {
        $role = new Athlete(); // Utilisez la classe Athlete
        $date = new DateTime($athleteEntity->getDateNaissance());
        $poids = floatval($athleteEntity->getPoids());
        $taille = floatval($athleteEntity->getTaille());

        $user = new User(
            $athleteEntity->getNom(),
            $athleteEntity->getPrenom(),
            $athleteEntity->getUsername(),
            $athleteEntity->getEmail(),
            $athleteEntity->getMotDePasse(),
            $athleteEntity->getSexe(),
            $taille,
            $poids,
            $date,
            $role
        );

        return $user;
    }

    public function athleteToEntity(User $user):AthleteEntity{

        $ath = new AthleteEntity();
        $ath->setIdAthlete($user->getId());
        $ath->setNom($user->getNom());
        $ath->setPrenom($user->getPrenom());
        $ath->setUsername($user->getUsername());
        $ath->setEmail($user->getEmail());
        $ath->setSexe($user->getSexe());
        $ath->setTaille($user->getTaille());
        $ath->setPoids($user->getPoids());
        $ath->setMotDePasse($user->getMotDePasse());
        $ath->setDateNaissance($user->getDateNaissance());
        $ath->setIsCoach(FALSE);
        $ath->setCoachId(NULL);

        return $ath;
    }

}

?>
