<?php

namespace Database;

use DateTime;
use Model\Athlete;
use Model\Training;
use Model\User;
use Shared\Log;

class EntrainementMapper
{
    public function entrainementSqlToEntity(array $data): array {
        $entrainementEntities = [];

        foreach ($data as $entrainementData) {
            $entrainement = new EntrainementEntity();

            if (isset($entrainementData['identrainement'])) {
                $entrainement->setIdEntrainement($entrainementData['identrainement']);
            }

            if (isset($entrainementData['date'])) {
                $entrainement->setDate($entrainementData['date']);
            }

            if (isset($entrainementData['description'])) {
                $entrainement->setDescription($entrainementData['description']);
            }

            if (isset($entrainementData['latitude'])) {
                $entrainement->setLatitude($entrainementData['latitude']);
            }

            if (isset($entrainementData['longitude'])) {
                $entrainement->setLongitude($entrainementData['longitude']);
            }

            if (isset($entrainementData['feedback'])) {
                $entrainement->setFeedback($entrainementData['feedback']);
            }

            if (isset($entrainementData['athleteid'])) {
                $entrainement->setCoachId($entrainementData['athleteid']);
            }

            $entrainementEntities[] = $entrainement;
        }

        return $entrainementEntities;
    }

    public function entrainementEntityToModel(EntrainementEntity $entrainementEntity): Training {
        $date = new DateTime($entrainementEntity->getDate());
        $idTraining = intval($entrainementEntity->getIdEntrainement());
        $latitude = floatval($entrainementEntity->getLatitude());
        $longitude = floatval($entrainementEntity->getLongitude());

        return new Training(
            $idTraining,
            $date,
            $latitude,
            $longitude,
            $entrainementEntity->getDescription(),
            $entrainementEntity->getFeedback()
        );
    }

    public function entrainementToEntity(Training $training):EntrainementEntity{

        $train = new EntrainementEntity();
        $train->setIdEntrainement($training->getId());
        $train->setDate($training->getDate());
        $train->setDescription($training->getDescription());
        $train->setLatitude($training->getLatitude());
        $train->setLongitude($training->getLongitude());
        $train->setFeedback($training->getFeedback());
        $train->setCoachId(1);

        return $train;
    }
}