<?php

namespace Database;

use Shared\Log;

class NotificationGateway
{
    private Connexion $connection;

    public function __construct(Connexion $connection) {
        $this->connection = $connection;
    }

    public function getNotifications(): array
    {
        $query = "SELECT * FROM Notification";
        $res = $this->connection->executeWithErrorHandling($query);
        return $res;
    }

    public function addNotification(NotificationEntity $notif){
        $query = "INSERT INTO Notification (message, date, statut, urgence, athleteid) VALUES (:message, :date, :statut, :urgence, :idAthlete)";
        $params = [':message'=>$notif->getMessage(), ':date'=>$notif->getDate(), ':statut'=>$notif->getStatut(), ':urgence'=>$notif->getUrgence(), ':idAthlete'=>$notif->getIdAthlete()];
        return $this->connection->executeWithErrorHandling($query, $params);
    }
}